/**
 * Copyright (c) 2010, iPlant Collaborative, University of Arizona, Cold Spring Harbor Laboratories, University of Texas at Austin
 * This software is licensed under the CC-GNU GPL version 2.0 or later.
 * License: http://creativecommons.org/licenses/GPL/2.0/
 */
package taxonomyLookupService;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * This servlet class handles requests to engage the TaxonomyLookupService.
 * 
 * This servlet is not a SSWAP resource, just a form handler
 * to construct a query string invocation.
 */
public class EngageTaxonomyLookupServlet extends HttpServlet {
    
	/**
	 * Default
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Some simple constants
	 */
    private static final String taxonomyID = "taxonomyID";
    private static final String commonName = "commonName";
    private static final String TaxonomyLookupService = "http://localhost:8080/sswap/TaxonomyLookupService";
    
    @Override
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException {
        
    	// set up for redirection or forwarding (w/ a query string) to invoke the service
    	String uriStr = TaxonomyLookupService;
    	
        // POSTed to us from the input page
        String userInput = request.getParameter("userInput");
        if (userInput != null) {
        
        	userInput = userInput.trim();
        	// if passed an integer value, treat it as a taxonomyID, otherwise it is a commonName
        	String property;
        	try {
        		Integer.parseInt(userInput);
        		property = taxonomyID;
        	} catch ( Exception e ) {
        		property = commonName;
        	}
        
        	uriStr += "?" + property + "=" + userInput;
        }
        
        try {
        	response.sendRedirect(uriStr);
		} catch ( IOException e ) {
			throw new ServletException(e.getMessage());
		}
        
    }
    
}
